package  
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Matrix;
	import net.richardlord.coral.Matrix3d;
	import EqMath.*;
	/**
	 * ...
	 * @author Shiu
	 */
	[SWF(width = 550, height = 400)]
	public class Demo3 extends Sprite
	{
		private var curve_points:Vector.<Circle>;
		private var line_points:Vector.<Circle>;
		private var intersec_points:Vector.<Circle>;
		
		private var cubic_equation:EqCubic;
		private var n1:Matrix, n2:Matrix;
		private var m1:Matrix3d, m2:Matrix3d;
		
		public function Demo3() {
			curve_points = new Vector.<Circle>;
			line_points = new Vector.<Circle>;
			intersec_points = new Vector.<Circle>;
			
			populate(curve_points, 0xff0000, 4);
			populate(line_points, 0x0000ff, 2);
			populate(intersec_points, 0xffff00, 3, false);
			
			cubic_equation = new EqCubic();
			redraw();
			recalculate_reposition();
		}
		
		private function populate(array:Vector.<Circle>,col:Number, total:Number, userControlled:Boolean = true):void {
			for (var i:int = 0; i < total; i++) {
				var c:Circle = new Circle(col, 5);	addChild(c);
				
				if (userControlled) {
					
					//randomise location
					c.x = Math.random() * stage.stageWidth;
					c.y = Math.random() * stage.stageHeight;
					
					//add event listerners
					c.addEventListener(MouseEvent.MOUSE_DOWN, mouseControl);
					c.addEventListener(MouseEvent.MOUSE_UP, mouseControl);
				}
				
				array[i] = c;
			}
		}
		
		private function mouseControl(e:MouseEvent):void 
		{
			if (e.type == "mouseDown") {
				e.currentTarget.startDrag();
				e.currentTarget.addEventListener(Event.ENTER_FRAME, refresh);
			}
			else if (e.type == "mouseUp") {
				e.currentTarget.stopDrag();
				e.currentTarget.removeEventListener(Event.ENTER_FRAME, refresh);
			}
		}
		
		private function refresh(e:Event):void 
		{
			redraw()
			recalculate_reposition()
		}
		
		private function redraw():void 
		{
			var cmd:Vector.<int> = new Vector.<int>;
			var coord:Vector.<Number> = new Vector.<Number>;
			
			//redraw curve;
			m1 = new Matrix3d(
				curve_points[0].x * curve_points[0].x * curve_points[0].x, curve_points[0].x * curve_points[0].x, curve_points[0].x, 1,
				curve_points[1].x * curve_points[1].x * curve_points[1].x, curve_points[1].x * curve_points[1].x, curve_points[1].x, 1,
				curve_points[2].x * curve_points[2].x * curve_points[2].x, curve_points[2].x * curve_points[2].x, curve_points[2].x, 1,
				curve_points[3].x * curve_points[3].x * curve_points[3].x, curve_points[3].x * curve_points[3].x, curve_points[3].x, 1
			);
			
			m2 = new Matrix3d(
				curve_points[0].y, 0, 0, 0,
				curve_points[1].y, 0, 0, 0,
				curve_points[2].y, 0, 0, 0,
				curve_points[3].y, 0, 0, 0
			)
			
			m1.invert();
			m2.append(m1);
			cubic_equation.define(m2.n11, m2.n21, m2.n31, m2.n41);
			
			for (var i:int = 0; i < stage.stageWidth; i+=2) 
			{
				if (i == 0) cmd.push(1);
				else		cmd.push(2);
				
				coord.push(i, cubic_equation.fx_of(i));
			}
			
			//draw line
			n1 = new Matrix();
			n1.a = line_points[0].x; n1.c = 1;
			n1.b = line_points[1].x; n1.d = 1;
			
			n2 = new Matrix();
			n2.a = line_points[0].y; n2.c = 0;
			n2.b = line_points[1].y; n2.d = 0;
			
			n1.invert();
			n2.concat(n1);
			
			var x:Number = stage.stageWidth		//y = mx + c
			cmd.push(1);	coord.push(0, n2.a * 0 + n2.b);
			cmd.push(2);	coord.push(x, n2.a * x + n2.b);
			
			graphics.clear();
			graphics.lineStyle(1);
			graphics.drawPath(cmd, coord);
		}
		
		private function recalculate_reposition():void 
		{
			cubic_equation.define(m2.n11, m2.n21 , m2.n31 - n2.a, m2.n41 - n2.b);
			cubic_equation.calcRoots();
			
			var roots:Vector.<Number> = cubic_equation.roots_R;
			
			for (var i:int = 0; i < roots.length; i++) 
			{
				if (!isNaN(roots[i])) {
					intersec_points[i].x = roots[i]; intersec_points[i].y = n2.a * roots[i] + n2.b
				}
				else {
					intersec_points[i].x = -100; intersec_points[i].y = -100;
				}
			}
		}
	}

}